/*
**
*/

#include <time.h>
#include <stdlib.h>
#include <qdos.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <qptr.h>

char _prog_name[]="pic 2 bmp converter";
char _version[]="1.0";
char _copyright[]="Absolutly Free";
void (*_consetup)()= consetup_title;


/*======================================================fwrite_BMFILE_HEADER==*/
void fwrite_BMfile_header(FILE *fp, short height, short wide, unsigned long adju)
{
   long x;
   char bmh[] = {  'B', 'M',       /* Flag for Bit Map                */
                          118, 0, 1, 0,   /* File size in bytes (not DWORDS) */
                          0, 0, 0, 0,     /* Reserved 1 & reserved 2         */
                          54, 0, 0, 0    /* Offset (bytes) to the bitmap    */
                       };
   x = height*wide*3+54+adju;
   bmh[2]= x & 0x00FF;
   bmh[3]= (x >>8) & 0x00FF;
   bmh[4]= (x >>16) & 0x00FF;
   bmh[5]= (x >>24) & 0x00FF;

   /*------------------------------------------*
    * Simply fwrite the above characters to the *
    * PC bitmap file.                          *
    *------------------------------------------*/
   fwrite(bmh,sizeof(bmh),1,fp);

}

/*=============================================================fwrite_BMINFO==*/
void fwrite_BMInfo(FILE *fp,short height, short wide, unsigned long adju)
{
   long x;
   static char bmi[] = {  40, 0, 0, 0,    /* Bytes in this header   */
                          0, 2, 0, 0,     /* Width in pixels = 512  */
                          0, 1, 0, 0,     /* Height in pixels = 256 */
                          1, 0,           /* Planes = 1             */
                          24, 0,           /* Bits per pixel = 4     */
                          0, 0, 0, 0,     /* Compression = none     */
                          0, 0, 1, 0,     /* Image size in Bytes    */
                          0, 6, 0, 0,     /* Pixels per metre wide  */
                          0, 9, 0, 0,     /* Pixels per meter high  */
                          0, 0, 0, 0,     /* Colours in index used  */
                          0, 0, 0, 0     /* Important colours used */
                       };
   bmi[4]=wide & 0x00FF;
   bmi[5]=(wide >> 8) & 0x00FF;

   bmi[8]=height & 0x00FF;
   bmi[9]=(height >> 8) & 0x00FF;

   x = wide * height * 3 + adju;
   bmi[20]= x & 0x00FF;
   bmi[21]= (x >>8) & 0x00FF;
   bmi[22]= (x >>16) & 0x00FF;
   bmi[23]= (x >>24) & 0x00FF;

   /*--------------------------------------*
    * fwrite the above info to the PC file. *
    *--------------------------------------*/
   fwrite(bmi,40,1,fp);
}


main(argc,argv)
char argc;
char **argv;
{
FILE *in,*out;
unsigned char rval,gval,bval;
short key, row;
unsigned short line=10;
unsigned char *buffer;
unsigned char mode,spare;
unsigned long adjust,n,k;
short height,width,i,j,l,a,remain;
if (argc!=3) {printf("Usage : %s in_pic out_bmp\n\tin_pic is a PE pic file\n\tout_bmp is BMP file\n",argv[0]); exit(0);}

in=fopene(argv[1],"rb",1); /* search data then prog directory */
if (!in) {printf("Input file : not found\n"); exit(0);}

out=fopen(argv[2],"wb"); /* in data directory, default */
if (!out) {printf("Output file : Error (Cannot open)\n"); exit(0);}

fread(&key,2,1,in);
if (key != 0x4AFC)
{
printf("Input file : Not a PE _pic file (no 4AFC tag)\n"); exit(0);
}
fread(&width,2,1,in);
fread(&height,2,1,in);
fread(&row,2,1,in);
fread(&mode,1,1,in);
fread(&spare,1,1,in);
if (spare==64) { mode = 33; } /* kludge for _piq, like the papa512_piq of qiv */

if ((mode!=0)&&(mode!=8)&&(mode!=33)&&(mode!=32))
{
printf("Input file : other mode than 4, 8, 32 and 33 not yet supported\n"); exit(0);
}


buffer=malloc(row*height);
if (!buffer) {
   fclose(in);
   fclose(out);
   printf("Run out of allocable memory (in one block : %d wanted...\n",row*height); exit(0);
   }

fread(buffer,row*height,1,in);


   fwrite_BMfile_header(out,height,width,0);
   fwrite_BMInfo(out,height,width,0);

switch(mode)
{
   case 0:
   case 8:
     a = 8;
   break;
   case 33:
   case 32:
     a = 1;
     break;
}
adjust  = 0;

if ((mode == 8)&&(width & 0x01))
 {
  width +=1;
 }

for(j=0;j<height;j++)
{
  n=0;
  k=(height-1-j)*row;
  remain = width;
  for(i=0;i*a<width;i++,k+=2)
    {
      unsigned char red,green,c,aa,b;
      green=buffer[k];
      red=buffer[k+1];
      switch(mode)
      {
      case 8: /* mode 8 */
      for(l=0;(remain>0)&&(l<4);remain-=2,l++)
        {
          aa=0x03&(red>>(6-2*l));
          b=(0x02&(green>>(6-2*l)))>>1;
          switch (aa+4*b)
          {
            case 0: bval=0;gval=0;rval=0; break;
            case 1: bval=255;gval=0;rval=0; break;
            case 2: bval=0;gval=0;rval=255; break;
            case 3: bval=255;gval=0;rval=255; break;
            case 4: bval=0;gval=255;rval=0; break;
            case 5: bval=255;gval=255;rval=0; break;
            case 6: bval=0;gval=255;rval=255; break;
            case 7: bval=255;gval=255;rval=255; break;
          }
          fwrite(&bval,1,1,out);
          fwrite(&gval,1,1,out);
          fwrite(&rval,1,1,out);
          fwrite(&bval,1,1,out);
          fwrite(&gval,1,1,out);
          fwrite(&rval,1,1,out);
          n+=6;
        }
        break;
        case 0: /* mode 4 */
        for(l=0;(remain>0)&&(l<8);remain--,l++)
        {
          aa=0x01&(red>>(7-l));
          b=0x01&(green>>(7-l));
          switch (aa+2*b)
          {
            case 0: bval=0;gval=0;rval=0; break;
            case 1: bval=0;gval=0;rval=255; break;
            case 2: bval=0;gval=255;rval=0; break;
            case 3: bval=255;gval=255;rval=255; break;
          }
          fwrite(&bval,1,1,out);
          fwrite(&gval,1,1,out);
          fwrite(&rval,1,1,out);
          n+=3;
        }
        break;
        case 33:
        for(l=0;(remain>0)&&(!l);remain--,l++)
        {
          bval = ( (0x3E & red)<<2 ) + (0x07 * (red & 0x01));
          rval = (( green & 0x07)<<5 ) + ((red & 0xC0)>>3) + (0x07 * (red & 0x01));
          gval = ( green & 0xF8) + (0x07 * (red & 0x01));
          fwrite(&bval,1,1,out);
          fwrite(&gval,1,1,out);
          fwrite(&rval,1,1,out);
          n+=3;

        }
        break;
        case 32:
        for(l=0;(remain>0)&&(!l);remain--,l++)
        {
          bval = ( (0x1F & green)<<3);
          rval = ( (red & 0xF8));
          gval = (( green & 0xE0) >>3)+(( red & 0x07)<<5) ;
          gval |= (gval >>6);
          bval |= (bval >>5);
          rval |= (rval >>5);
          fwrite(&bval,1,1,out);
          fwrite(&gval,1,1,out);
          fwrite(&rval,1,1,out);
          n+=3;

        }
        break;
      }
    }
    n %= 4;
    n = 4-n;
    n %= 4;

    rval=0;
    for(adjust+=n;n;n--)
    {
      fwrite(&rval,1,1,out);
    }
  }

  fseek(out,0,SEEK_SET);
  fwrite_BMfile_header(out,height,width,adjust);
  fwrite_BMInfo(out,height,width,adjust);
  fseek(out,0,SEEK_END);
  fclose(in);
  fclose(out);
  return(0);

}
